unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls,LogBookUnit, SpaceObjectUnit, ExtCtrls, Jpeg;

type
  TMainForm = class(TForm)
    OpenDialog: TOpenDialog;
    OpenButton: TButton;
    StringGrid: TStringGrid;
    SortRadioGroup: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    MinDiameter: TEdit;
    MaxDiameter: TEdit;
    ApplyButton: TButton;
    Label3: TLabel;
    YearLabel: TLabel;
    Label4: TLabel;
    CountryLabel: TLabel;
    Label5: TLabel;
    TypeLabel: TLabel;
    Label6: TLabel;
    NameLabel: TLabel;
    Label7: TLabel;
    AgeLabel: TLabel;
    Label8: TLabel;
    DiameterLabel: TLabel;
    Image: TImage;
    procedure OpenButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowLogBook;
    procedure ShowSelectedObject(Row:integer);
    procedure ApplyButtonClick(Sender: TObject);
    procedure StringGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  LogBook:TLogBook;
implementation

{$R *.dfm}

procedure TMainForm.ApplyButtonClick(Sender: TObject);
begin
 ShowLogBook;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 LogBook:=TLogBook.Create;
 ShowLogBook;
end;

procedure TMainForm.OpenButtonClick(Sender: TObject);
begin
 if OpenDialog.Execute then
 begin
  try
    LogBook.LoadFromFile(OpenDialog.FileName);
  except
     on E:Exception do
     begin
        ShowMessage('    .');
        LogBook.Free;
        LogBook:=TLogBook.Create;
     end;
  end;
  ShowLogBook;
 end;
end;

procedure TMainForm.ShowLogBook;
var i:integer;
  min,max:integer;
  s:string;
begin
  s:=Trim(MinDiameter.Text);
  if s='' then s:='0';
  min:=StrToInt(s);
  s:=Trim(MaxDiameter.Text);
  if s='' then s:='0';
  max:=StrToInt(s);
  LogBook.Filter(min,max);
  if SortRadioGroup.ItemIndex=1 then
    LogBook.SortByName;
  if SortRadioGroup.ItemIndex=2 then
    LogBook.SortByDiameter;
  StringGrid.Cells[0,0]:='';
  StringGrid.Cells[1,0]:='';
  StringGrid.RowCount:=2;
  if LogBook.list.Count>0 then
    StringGrid.RowCount:=LogBook.list.Count+1;
  for i := 0 to LogBook.List.Count - 1 do
  begin
    StringGrid.Cells[0,i+1]:=LogBook.List[i].Name;
    StringGrid.Cells[1,i+1]:=IntToStr(LogBook.List[i].Diameter);
  end;
  StringGrid.Row:=1;
  ShowSelectedObject(1);
end;

procedure TMainForm.ShowSelectedObject(Row:integer);
var i:integer;
   spaceObj:TSpaceObject;
   artObj:TArtificialObject;
   natObj:TNaturalObject;
   imageFileName:string;
begin
   //  
   TypeLabel.Caption:='';
   NameLabel.Caption:='';
   DiameterLabel.Caption:='';
   YearLabel.Caption:='';
   CountryLabel.Caption:='';
   AgeLabel.Caption:='';
   Image.Picture:=nil;

   //   ,    
   i:=Row-1;
   if (i>=0) and (LogBook.list.Count>i) then
   begin
     spaceObj:=LogBook.list.Items[i];
     NameLabel.Caption:=spaceObj.Name;
     DiameterLabel.Caption:=IntToStr(spaceObj.Diameter) + ' ';
     imageFileName:=LogBook.Catalog + '\' + spaceObj.Image;
     try
      Image.Picture.LoadFromFile(imageFileName);
     except
      Image.Picture:=nil;
     end;
     if spaceObj.ClassType=TArtificialObject then
     begin
        artObj:=TArtificialObject(spaceObj);
        TypeLabel.Caption:='';
        YearLabel.Caption:=IntToStr(artObj.Year);
        CountryLabel.Caption:=artObj.Country;
     end
     else
     begin
        natObj:=TNaturalObject(spaceObj);
        TypeLabel.Caption:='';
        AgeLabel.Caption:=natObj.Age;
     end;
   end

end;

procedure TMainForm.StringGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  ShowSelectedObject(ARow);
end;

end.
