unit SpaceObjectUnit;

interface
 type
  TSpaceObject=class abstract (TObject)
    protected
     fName:string;
     fDiameter:integer;
     fImage:string;

    public
     property Name:string read fName;
     property Diameter:integer read fDiameter;
     property Image:string read fImage;
     procedure ReadFromFile(var f:TextFile); virtual;
     procedure Print; virtual;
  end;

  TArtificialObject=class(TSpaceObject)
    protected
      fYear:integer;
      fCountry:string;
    public
     property Country:string read fCountry;
     property Year:integer read fYear;
     procedure ReadFromFile(var f:TextFile); override;
     procedure Print; override;
  end;

  TNaturalObject=class(TSpaceObject)
    protected
      fAge:string;
    public
      property Age:string read fAge;
      procedure ReadFromFile(var f:TextFile); override;
      procedure Print; override;
  end;

implementation

   procedure TSpaceObject.ReadFromFile(var f: TextFile);
   begin
    readln(f,fName);
    readln(f,fDiameter);
    readln(f,fImage);
   end;

   procedure TSpaceObject.Print;
   begin
     writeln(': ',Name);
     writeln(': ', Diameter);
     writeln(': ', Image);
   end;

   procedure TArtificialObject.ReadFromFile(var f: TextFile);
   begin
    inherited ReadFromFile(f);
    readln(f,fYear);
    readln(f,fCountry);
   end;

   procedure TArtificialObject.Print;
   begin
    writeln(' ');
    inherited Print;
    writeln(': ',Year);
    writeln(': ',Country);
   end;

   procedure TNaturalObject.ReadFromFile(var f: TextFile);
   begin
    inherited readFromFile(f);
    readln(f,fAge);
   end;

   procedure TNaturalObject.Print;
   begin
    writeln(' ');
    inherited Print;
    writeln(': ',Age);
   end;

end.
